package com.V10lator.SignClock;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.Reader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringWriter;
import java.io.Writer;
import org.bukkit.block.Block;
import org.bukkit.Material;
import org.bukkit.Server;
import org.bukkit.World;

public class Init
{
  public final File saveFile;
  private final Server server;
  public String saveRAM;
  private final SignClock plugin;
  
  public Init(SignClock plugin)
  {
	this.saveRAM = "";
	this.plugin = plugin;
	this.server = plugin.getServer();
	this.saveFile = new File("plugins/V10lator/"+plugin.name+".sav");
  }
  
  public int initialize(short step)
  {
	if(step == 0)
	{
	  //create|check Theme folder
      File themeDir = new File("plugins/V10lator/themes");

      if(!themeDir.exists())
      {
        if(themeDir.mkdir())
          this.plugin.info2log("info: create theme folder");
        else
        {
          this.plugin.info2log("error: can't create theme folder");
          return -1;
        }
      }
      
      //create|check saveFile
      if(!saveFile.exists())
        try
        {
          saveFile.createNewFile();
          this.plugin.info2log("info: save file created");
        }
        catch (IOException e)
        {
          this.plugin.info2log("error: can't create "+this.plugin.name+" save file, Signs will not be saved!");
          e.printStackTrace();
          return -1;
        }

        //create|check themeFiles
        int count = 1;
        while(count <= 5)
        {
	      File themeFile = new File("plugins/V10lator/themes/" + count + ".sgt");
	      if(!themeFile.exists())
	      {
	        try
	        {
		      themeFile.createNewFile();
	        }
	        catch (IOException e)
	        {
		      this.plugin.info2log("error: can't create 'plugins/V10lator/themes/" + count + ".sgt'");
		      e.printStackTrace();
		      return -1;
            }
	        try
	        {
		      InputStream stream=this.getClass().getResourceAsStream("/com/V10lator/SignClock/themes/" + count + ".sgt");
		      if(stream!=null) {
			    Writer tmpwriter = new StringWriter();
			    char[] buffer = new char[1024];
			    String out = "";
			    try
			    {
			      Reader reader = new BufferedReader(
			      new InputStreamReader(stream, "UTF-8"));
			      int n;
			      while((n = reader.read(buffer)) != -1)
			      {
			        tmpwriter.write(buffer, 0, n);
			        out = out + tmpwriter;
			      }
			      FileWriter writer = new FileWriter(themeFile);
			      writer.write(out);
			      writer.close();
			      tmpwriter.close();
			    }
			    catch (IOException e)
			    {
			      this.plugin.info2log("BUG (IOExpection at 190)");
			      e.printStackTrace();
			      return -1;
			    }
			    finally
			    {
			      stream.close();
			    }
		      }
		      else
		        return -1;
	        }
	        catch(IOException ioe)
	        {
		      /* was auch immer */
		      this.plugin.info2log("debug2");
		      return -1;
	        }
	      }
	      count++;
        }
        return 0;
	}
	else if(step == 1)
	{
	  int count = 0;
	  try {
		BufferedReader reader = new BufferedReader(new FileReader(saveFile));
		Block block = null;
		SClock sign = null;
		String saveRAM = "";
		
		String[] result = null;
		String out = null;

		//read Data
		boolean first = true;
		while(reader.ready())
		{
		  World world = null;
		  out = reader.readLine();
		  saveRAM = saveRAM + out + "\n";
		  result = out.split(",");
		  if(first && result[0].equals("V1"))
		  {
			if(!result[2].equals("null"))
			{
			  this.plugin.setMagicSign(plugin.getServer().getWorld(result[1]).getBlockAt(Integer.parseInt(result[2]), Integer.parseInt(result[3]), Integer.parseInt(result[4])));
			  if(result[5].equals("0"))
				this.plugin.setMagic(false);
			  else
				this.plugin.setMagic(true);
			}
			first = false;
		  }
		  else
		  {
		    block = this.server.getWorld(result[0]).getBlockAt(Integer.parseInt (result[1]), Integer.parseInt (result[2]), Integer.parseInt (result[3]));
		  
		    sign = new SClock();
		    sign.setWorld(result[0]);
		    sign.setX(Integer.parseInt (result[1]));
		    sign.setY(Integer.parseInt (result[2]));
		    sign.setZ(Integer.parseInt (result[3]));
		    sign.setStyle(result[4]);
		    sign.setState(0);
		  
		    world = plugin.getServer().getWorld(sign.getWorld());

		    //get Block
		    if(world != null)
			  block = world.getBlockAt(sign.getX(), sign.getY(), sign.getZ());
		    else
			  break;
		  
		    if(block != null && block.getType() == Material.SIGN_POST || block.getType() == Material.WALL_SIGN && !this.plugin.isSignClock((block)))
		    {
			  boolean trigger = false;
			  if(Integer.parseInt(result[5]) == 1)
			  {
			    trigger = true;
			    this.plugin.triggerRAM.addSign(result[0], Integer.parseInt(result[1]), Integer.parseInt(result[2]), Integer.parseInt(result[3]));
			  }
			  sign.setSelfTriggered(trigger);
			  boolean daytime = false;
			  if(result.length == 7 && Integer.parseInt(result[6]) == 1)
			  {
			    daytime = true;
			  }
			  sign.setDaytime(daytime);
		      plugin.addSign(block, sign);
			  count++;
		    }
		  }
		}
		this.saveRAM = saveRAM;
	  }
      catch (FileNotFoundException e)
	  {
	  }
	  catch (IOException e)
	  {
	  }
	  return count;
	}
	else
	  return -1;
  }
}
