package com.V10lator.SignClock;

import java.io.FileWriter;
import java.io.IOException;
import java.util.Collection;
import org.bukkit.block.Block;

public class SaveThread extends Thread
{
  private final SignClock plugin;
  public SaveThread(final SignClock plugin)
  {
    this.plugin = plugin;
  }
  
  public void run()
  {
    int ret = save();
    if(ret < 0)
    {
      if(ret == -2)
        this.plugin.info2log("No new save data.");
      else
    	this.plugin.info2log("Can't save (" + ret + ")");
    }
	else
	  this.plugin.info2log(ret + " Events saved");
  }
  
  public short save()
  {
	//Write file to ram
	Collection<SClock> signs = plugin.getValues();
	String out = "V1,";
	if(this.plugin.getMS() != null)
	{
	  Block ms = this.plugin.getMS();
      out = out + 
            ms.getWorld().getName() + "," +
            ms.getX() + "," +
            ms.getY() + "," +
            ms.getZ() + ",";
	}
	else
	  out = out + "null,null,null,null,";
    if(this.plugin.isMagicActive())
      out = out + "1\n";
    else
      out = out + "0\n";
    
    short c = 0;
	for(SClock sign: signs)
	{
	  short trigger = 0;
	  if(sign.isTriggered())
		trigger = 1;
	  short daytime = 0;
	  if(sign.isDaytime())
		daytime = 1;
	  out = out + 
		    sign.getWorld() + "," + 
		    sign.getX() + "," + 
		    sign.getY() + "," + 
		    sign.getZ() + "," + 
		    sign.getStyle() + "," + 
		    trigger + "," +
		    daytime + "\n";
	  c++;
	}
	if(plugin.Init.saveRAM.equals(out))
	  return -2;
	
	try
	{
	  FileWriter writer = new FileWriter(this.plugin.Init.saveFile);
	  writer.write(out);
	  plugin.Init.saveRAM = out;
	  writer.close();
	}
	catch (IOException e)
	{
	  return -1;
	}
	return c;
  }
}

